"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mocks = require("./mocks");

let currentModule;

const loadInRoll = (mocks, middleTick) => {
  if (mocks.length) {
    currentModule = mocks[0];
    currentModule.result = currentModule.creator();
    if (currentModule.result && currentModule.result.then) {
      return middleTick().then(() => currentModule.result).then(() => loadInRoll(mocks.slice(1), middleTick));
    } else {
      return loadInRoll(mocks.slice(1), middleTick);
    }
  } else {
    return Promise.resolve();
  }
};

const probeAsyncModules = {
  hasAsyncModules() {
    const mocks = (0, _mocks.getAllAsyncMocks)();
    return mocks.length ? mocks : false;
  },

  load: Module => (request, parent) => {
    currentModule.loaded = true;
    const baseRequest = Module._resolveFilename(request, parent);
    currentModule.mock.name = baseRequest;
    (0, _mocks.insertMock)(baseRequest, currentModule.mock);
  },

  execute(middleTick) {
    const mocks = (0, _mocks.getAllAsyncMocks)();
    return loadInRoll(mocks, middleTick);
  }
};

exports.default = probeAsyncModules;